

function CommonUse()
{
	var ForReading = 1; // Read from file
	var ForWriting = 2; // Write to file
	var ForAppending = 8; // Append to file
	
	/*
	*	Read content from file
	*/
	this.ReadFile = function(filename)
	{ 
		var fso = new ActiveXObject("Scripting.FileSystemObject");
		if (!fso.FileExists(filename))
		{
			return "";
		}
		
		var f = fso.OpenTextFile(filename, ForReading);
		var s = "";
		while (!f.AtEndOfStream)
		{
			s += f.ReadLine()+"\n"; 
		}
		f.Close(); 
		return s; 
	} 
	
	// Write content to file
	this.WriteFile = function(filename,filecontent){ 
	    var fso, f, s ; 
	    fso = new ActiveXObject("Scripting.FileSystemObject");    
	    f = fso.OpenTextFile(filename, ForWriting, true); 
	    f.WriteLine(filecontent);   
	    f.Close(); 
	} 
	
	// Append content to file
	this.AppendFile = function(filename,filecontent){ 
	    var fso, f, s ; 
	    fso = new ActiveXObject("Scripting.FileSystemObject");    
	    f = fso.OpenTextFile(filename, ForAppending, true); 
	    f.WriteLine(filecontent);   
	    f.Close(); 
	}
	
	this.IsNormalIP = function(szIP)
	{
		/*
		*	Check if the IP is valid and it isn't a multicast IP and and its last position can't be 0 and it can't be "255.255.255.255"
		*/
		// var	reExp = /^(\d{1,2}|1\d\d|2[0-1]\d|22[0-3])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(0{0,2}[1-9]|0[1-9]\d|\d[1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
		var	reExp = /^(\d|[1-9]\d|1\d\d|2[0-1]\d|22[0-3])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
		var vResult = szIP.match(reExp); 
		
		if (null == vResult) 
		{ 
			return false;
		}
				
		return true;
	}
	
	this.IsNetMask = function(szIP)
	{
		var		arrMask = new Array();
		var		iMask1 = 0;
		var		iMask2 = 0;
		var		iMask3 = 0;
		var		iMask4 = 0;
		var		iMaskNum = 0;
		var		i = 0;
		var		iValidMask = 0;
		
		if ( !this.IsIP(szIP) )
		{
			// It isn't a valid IP.
			return false;
		}
		
		// split the input IP string
		arrMask = szIP.split(".");
		iMask1 = parseInt(arrMask[0]);
		iMask2 = parseInt(arrMask[1]);
		iMask3 = parseInt(arrMask[2]);
		iMask4 = parseInt(arrMask[3]);
		// the integer value of IP
		iMaskNum = iMask1 * 0x1000000 + iMask2 * 0x10000 + iMask3 * 0x100 + iMask4;
		iValidMask = 0xffffffff;
		
		for (i=0; i<32; i++)
		{
			if (iMaskNum == iValidMask)
			{
				break;
			}
			
			// shift a bit to left
			iValidMask = iValidMask << 1;
			if (iValidMask < 0)
			{
				iValidMask = iValidMask + 0xffffffff + 1;
			}
		}
		
		if (0xffffffff == iMaskNum || 32 == i)
		{
			return false;
		}
		
		return true;
	}
	
	this.IsIP = function(szIP) 
	{ 
		var reExp = /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$/; 
		var vResult = szIP.match(reExp); 
		
		if (null == vResult) 
		{ 
			return false;
		}
		
		return true;
	}
	
	/*************************************************************************************************************
	* Name			: GetAbsoluteLeft
	* Function		: Get the absolute distance that an object is to be away from the left margin of the body.
	* Input			: ob, the object that needs to get the distance to be away from the left margin of the body.
	* Output		: iLeft, the distance that ob is to be away from the left margin of the body.
	*************************************************************************************************************/
	this.GetAbsoluteLeft = function(ob)
	{
		var		oElm = null;
		var		iLeft = 0;
		
		if (!ob)
		{
			// The object doesn't exist and then return 0
			return 0;
		}
		
		oElm = ob;
		iLeft = oElm.offsetLeft;
		while (   null != oElm 
			&& null != oElm.offsetParent
			&& "BODY" != oElm.offsetParent.tagName.toUpperCase()
		)
		{
			// Accumulate the distance that the current element object is to be away from its parent element left
			iLeft += oElm.offsetParent.offsetLeft;
			oElm = oElm.offsetParent;
		}
		
		return iLeft;
	}


	/*************************************************************************************************************
	* Name			: GetAbsoluteTop
	* Function		: Get the absolute distance that an object is to be away from the top margin of the body.
	* Input			: ob, the object that needs to get the distance to be away from the top margin of the body.
	* Output		: iTop, the distance that ob is to be away from the top margin of the body.
	*************************************************************************************************************/
	this.GetAbsoluteTop = function(ob)
	{
		var		oElm = null;
		var		iTop = 0;
		
		if (!ob)
		{
			// The object doesn't exist and then return 0
			return 0;
		}
		
		oElm = ob;
		iTop = oElm.offsetTop;
		while (   null != oElm
			&& null != oElm.offsetParent
			&& "BODY" != oElm.offsetParent.tagName
		)
		{
			// Accumulate the distance that the current element object is to be away from its parent element top
			iTop += oElm.offsetParent.offsetTop;
			oElm = oElm.offsetParent;
		}
		
		return iTop ;
	}

	this.GetAbsoluteRootPath = function () {
	    var szCfgFilePath = "";
	    var szCurPath = document.location.pathname;
	    var iIdx = szCurPath.lastIndexOf("\\documents\\");
	    if (iIdx > 0) {
	        szCfgFilePath = szCurPath.substring(0, iIdx) + "\\";
	    }
	    else {
	        iIdx = szCurPath.lastIndexOf("\\Agreement\\");
	        if (iIdx > 0) {
	            szCfgFilePath = szCurPath.substring(0, iIdx) + "\\";
	        }
	    }

	    return szCfgFilePath;
	}

    this.GetCookie = function (Name) { //get cookie value
        var re = new RegExp(Name + "=[^;]+", "i"); //construct RE to search for target name/value pair
        if (document.cookie.match(re)) //if cookie found
            return document.cookie.match(re)[0].split("=")[1]; //return its value
        //return ""
    }
}

function CUsbActionCfg() {
	var _oCommonUse									= new CommonUse();
	var USB_ACTION_CFG_FILE_NAME					= _oCommonUse.GetAbsoluteRootPath() + "usb_action.cfg";
	var USB_IP_NETWORK_SETTING						= "USB_IP_NETWORK_SETTING";
	var USB_RESTORE_TO_FACTORY_SECURITY_DEFAULTS	= "USB_RESTORE_TO_FACTORY_SECURITY_DEFAULTS";
	var USB_RESTORE_TO_FACTORY_DEFAULTS				= "USB_RESTORE_TO_FACTORY_DEFAULTS";
	var USB_UPGRADE_DOWNGRADE						= "USB_UPGRADE_DOWNGRADE";
	var USB_DIAGNOSTIC								= "USB_DIAGNOSTIC";
	var USER_SELECTED_VERSION						= "USER_SELECTED_VERSION";
	
	this.GetUsbActionCfgFileName = function()
	{
		return USB_ACTION_CFG_FILE_NAME;
	}
	
	this.GetUsbIpNetworkSettingStr = function()
	{
		return USB_IP_NETWORK_SETTING;
	}
	
	this.GetUsbRestoreToFactorySecurityDefaultsStr = function()
	{
		return USB_RESTORE_TO_FACTORY_SECURITY_DEFAULTS
	}
	
	this.GetUsbRestoreToFactoryDefaultsStr = function()
	{
		return USB_RESTORE_TO_FACTORY_DEFAULTS;
	}
	
	this.GetUsbUpgradeDowngradeStr = function()
	{
		return USB_UPGRADE_DOWNGRADE;
	}
	
	this.GetUserSelectedVersionStr = function()
	{
		return USER_SELECTED_VERSION;
	}

	this.GetUsbDiagnosticStr = function () {
		return USB_DIAGNOSTIC;
	}

	this.SaveCfg = function (arrCfg) {
		var szCfg = USB_IP_NETWORK_SETTING + "=" + (arrCfg[USB_IP_NETWORK_SETTING] ? "YES" : "NO") + "\n";
		szCfg += USB_RESTORE_TO_FACTORY_SECURITY_DEFAULTS + "=" + (arrCfg[USB_RESTORE_TO_FACTORY_SECURITY_DEFAULTS] ? "YES" : "NO") + "\n";
		szCfg += USB_RESTORE_TO_FACTORY_DEFAULTS + "=" + (arrCfg[USB_RESTORE_TO_FACTORY_DEFAULTS] ? "YES" : "NO") + "\n";
		szCfg += USB_DIAGNOSTIC + "=" + (arrCfg[USB_DIAGNOSTIC] ? "YES" : "NO") + "\n";
		szCfg += USB_UPGRADE_DOWNGRADE + "=" + (arrCfg[USB_UPGRADE_DOWNGRADE] ? "YES" : "NO") + "\n";
		szCfg += USER_SELECTED_VERSION + "=" + (arrCfg[USER_SELECTED_VERSION] ? arrCfg[USER_SELECTED_VERSION] : "");

		_oCommonUse.WriteFile(USB_ACTION_CFG_FILE_NAME, szCfg);
	}
}

function CLanCfg() {
	var _oCommonUse = new CommonUse();
	var LAN_CFG_FILE_NAME		= _oCommonUse.GetAbsoluteRootPath() + "lan.cfg";
	var GENERAL_INFORMATION		= "[GENERAL INFORMATION]";
	var MANAGMENT_IP_ADDR		= "MANAGMENT_IP_ADDR";
	var MANAGMENT_SUBNETMASK	= "MANAGMENT_SUBNETMASK";
	var MANAGMENT_DEFGATEWAY	= "MANAGMENT_DEFGATEWAY";
		
	this.GetLanCfgFileName = function()
	{
		return LAN_CFG_FILE_NAME;
	}
	
	this.GetGeneralInformationStr = function()
	{
		return GENERAL_INFORMATION;
	}
	
	this.GetManagmentIpAddrStr = function()
	{
		return MANAGMENT_IP_ADDR;
	}
	
	this.GetManagmentSubnetmaskStr = function()
	{
		return MANAGMENT_SUBNETMASK;
	}
	
	this.GetManagmentDefgatewayStr = function()
	{
		return MANAGMENT_DEFGATEWAY;
	}
	
	this.SaveCfg = function(arrCfg)
	{
		var szCfg = GENERAL_INFORMATION + "\n";
		szCfg += MANAGMENT_IP_ADDR + "=" + (arrCfg[MANAGMENT_IP_ADDR] ? arrCfg[MANAGMENT_IP_ADDR] : "") + "\n";
		szCfg += MANAGMENT_SUBNETMASK + "=" + (arrCfg[MANAGMENT_SUBNETMASK] ? arrCfg[MANAGMENT_SUBNETMASK] : "") + "\n";
		szCfg += MANAGMENT_DEFGATEWAY + "=" + (arrCfg[MANAGMENT_DEFGATEWAY] ? arrCfg[MANAGMENT_DEFGATEWAY] : "");

		_oCommonUse.WriteFile(LAN_CFG_FILE_NAME, szCfg);
	}

	this.LoadCfg = function (arrCfg) {
		var szCfg = _oCommonUse.ReadFile(LAN_CFG_FILE_NAME);
		var arrLine = szCfg.split("\n");
		for (var i = 0; i < arrLine.length; ++i) {
			if (-1 != arrLine[i].indexOf("=")) {
				arrField = arrLine[i].split("=");
				arrCfg[arrField[0]] = arrField[1];
			}
		}
	}
	
	this.RemoveCfgFile = function()
	{
		var fso = new ActiveXObject("Scripting.FileSystemObject");
		if (fso.FileExists(LAN_CFG_FILE_NAME))
		{
			fso.DeleteFile(LAN_CFG_FILE_NAME);
		}
	}
}


function CLanguageTranslation() {
    var _oCommonUse = new CommonUse();
    var _arrStrings = new Array();

    function _GetTranslationStringsSet(arrStrings) {
        var lang = _oCommonUse.GetCookie("Language");
        var szLanguageFileName = "en.xml";
        switch (lang) {
            case "CS":
                szLanguageFileName = "cs.xml";
                break;
            case "EN":
            case "JA":
            case "ES":
            case "FR":
            case "RU":
            case "GE":
            case "BP":
            case "HE":
            case "KO":
                break;
        }

        szLanguageFileName = _oCommonUse.GetAbsoluteRootPath() + "documents\\languages\\" + szLanguageFileName;
        var xmlObj = null;
        var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");

        xmlDoc.async = "false";
        xmlDoc.load(szLanguageFileName);
        xmlObj = xmlDoc.documentElement;
        for (var i = 0; i < xmlObj.childNodes.length; ++i) {
            var oFirstLevelElem = xmlObj.childNodes(i);
            if ("translations" == oFirstLevelElem.tagName.toLowerCase()) {
                for (var j = 0; j < oFirstLevelElem.childNodes.length; ++j) {
                    var oSecondLevelElem = oFirstLevelElem.childNodes[j];
                    if ("language" == oSecondLevelElem.tagName.toLowerCase()) {
                        _Parse2TranslationStringsSet(oSecondLevelElem, arrStrings);
                        break;
                    }
                }

                break;
            }
        }
    }

    function _Parse2TranslationStringsSet(oLanguageNode, arrStrings) {
        for (var i = 0; i < oLanguageNode.childNodes.length; ++i) {
            var oStringNode = oLanguageNode.childNodes[i];
            var szKey = "";
            var szValue = "";
            for (var j = 0; j < oStringNode.childNodes.length; ++j) {
                var oElem = oStringNode.childNodes[j];
                if ("key" == oElem.tagName.toLowerCase()) {
                    szKey = oElem.text;
                }
                else if ("value" == oElem.tagName.toLowerCase()) {
                    szValue = oElem.text;
                }
            }

            arrStrings[szKey] = szValue;

        }
    }

    this.GetTranslateString = function (szKey) {
        if (szKey in _arrStrings) {
            return _arrStrings[szKey];
        }

        return szKey;
    }

    _GetTranslationStringsSet(_arrStrings);

}